Package org.optaplanner.core.impl.score.stream.bavet.bi

## Class BavetGroupBiConstraintStream<Solution_,​GroupKey_,​ResultContainer_,​Result_>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiConstraintStream<Solution_,​GroupKey_,​Result_>
      - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetGroupBiConstraintStream<Solution_,​GroupKey_,​ResultContainer_,​Result_>

- All Implemented Interfaces:
    `BiConstraintStream<GroupKey_,​Result_>`, `ConstraintStream`, `InnerBiConstraintStream<GroupKey_,​Result_>`

      public final class BavetGroupBiConstraintStream<Solution_,​GroupKey_,​ResultContainer_,​Result_>
      extends BavetAbstractBiConstraintStream<Solution_,​GroupKey_,​Result_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiConstraintStream

      `childStreamList`

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetGroupBiConstraintStream​(BavetConstraintFactory<Solution_> constraintFactory, BavetAbstractConstraintStream<Solution_> parent, Function<ResultContainer_,​Result_> finisher)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected BavetGroupBiNode<GroupKey_,​ResultContainer_,​Result_>` | `createNode​(BavetNodeBuildPolicy<Solution_> buildPolicy, Score<?> constraintWeight, BavetAbstractBiNode<GroupKey_,​Result_> parentNode)` |
    `BavetGroupBiNode<GroupKey_,​ResultContainer_,​Result_>` | `createNodeChain​(BavetNodeBuildPolicy<Solution_> buildPolicy, Score<?> constraintWeight, BavetAbstractBiNode<GroupKey_,​Result_> parentNode)` |
    `List<BavetFromUniConstraintStream<Solution_,​Object>>` | `getFromStreamList()` |
    `boolean` | `guaranteesDistinct()` | This method will return true if the constraint stream is guaranteed to only produce distinct tuples.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiConstraintStream

      `addChildStream, createChildNodeChains, filter, flattenLast, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join, map, processNode`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractConstraintStream

      `buildConstraint, buildConstraintConfigurable, getConstraintFactory`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.bi.BiConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.bi.InnerBiConstraintStream

      `distinct, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### BavetGroupBiConstraintStream

          public BavetGroupBiConstraintStream​(BavetConstraintFactory<Solution_> constraintFactory,
                                              BavetAbstractConstraintStream<Solution_> parent,
                                              Function<ResultContainer_,​Result_> finisher)

  - ### Method Detail

    - #### guaranteesDistinct

          public boolean guaranteesDistinct()

      Description copied from interface: `InnerBiConstraintStream`
      This method will return true if the constraint stream is guaranteed to only produce distinct tuples. See `InnerBiConstraintStream.distinct()` for details.
      Returns:
        true if the guarantee of distinct tuples is provided

    - #### getFromStreamList

          public List<BavetFromUniConstraintStream<Solution_,​Object>> getFromStreamList()

      Specified by:
        `getFromStreamList` in class `BavetAbstractConstraintStream<Solution_>`

    - #### createNodeChain

          public BavetGroupBiNode<GroupKey_,​ResultContainer_,​Result_> createNodeChain​(BavetNodeBuildPolicy<Solution_> buildPolicy,
                                                                                                  Score<?> constraintWeight,
                                                                                                  BavetAbstractBiNode<GroupKey_,​Result_> parentNode)

      Overrides:
        `createNodeChain` in class `BavetAbstractBiConstraintStream<Solution_,​GroupKey_,​Result_>`

    - #### createNode

          protected BavetGroupBiNode<GroupKey_,​ResultContainer_,​Result_> createNode​(BavetNodeBuildPolicy<Solution_> buildPolicy,
                                                                                                Score<?> constraintWeight,
                                                                                                BavetAbstractBiNode<GroupKey_,​Result_> parentNode)

      Specified by:
        `createNode` in class `BavetAbstractBiConstraintStream<Solution_,​GroupKey_,​Result_>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`